﻿& 'C:\Program Files (x86)\Hantek6000\Scope.exe'                                    #付属アプリを起動する
while ( (Get-Process | Where-Object {$_.Name -match "scope"}) -eq $null ){}        #"scope"というプロセスが現れるまで待つ
$com = New-Object System.IO.Ports.SerialPort "COM2",                            #COM2を指定(環境により異なる)
9600,([System.IO.Ports.Parity]::None),8,([System.IO.Ports.StopBits]::One)        #9600bps,パリティなし,8bit,ストップビット1bit
$com.NewLine = [Char]0x0D + [Char]0x0A                                            #終端はCR+LF
$com.ReadTimeout = 100                                                            #受信のタイムアウトを100msとする
$com.Open()                                                                        #シリアルポートを開く
while ($data -ne "end") {                                                        #"end"という文字列を受信するまで無限ループ
    if( ( Get-Process | Where-Object {$_.Name -match "scope"} ) -eq $null ){    #付属アプリのプロセスが存在しなければ終了する
        $com.Close()
        $com.Dispose()
        exit
    }
    try{
        $data = $com.ReadLine()                                                   #シリアルポートから受信する
    }catch{
        continue                                                                #100msでタイムアウトが発生するのでそのまま継続
    }
    if ( $data.IndexOf('.set') -ne -1 ){                                        #".set"で終わる文字列を受信した場合その文字列のファイル名の設定ファイルを開く
        start-sleep -Milliseconds 3000
        [System.Windows.Forms.SendKeys]::SendWait("%f")
        start-sleep -Milliseconds 10
        [System.Windows.Forms.SendKeys]::SendWait("{down 3}")
        start-sleep -Milliseconds 10
        [System.Windows.Forms.SendKeys]::SendWait("{enter}")
        start-sleep -Milliseconds 10
        $retry_cnt = 0
        Set-Clipboard -Value "neko"
        do{
            
            [System.Windows.Forms.SendKeys]::SendWait(".")
            [System.Windows.Forms.SendKeys]::SendWait("^a")
            [System.Windows.Forms.SendKeys]::SendWait("^c")
            start-sleep -Milliseconds 100
            $clip_board = Get-Clipboard -Format Text
            $retry_cnt = $retry_cnt + 1
            if( $retry_cnt -gt 10 ){
                break
            }
        }while( $clip_board -ne "." )
        start-sleep -Milliseconds 10
        [System.Windows.Forms.SendKeys]::SendWait("^a")
        [System.Windows.Forms.SendKeys]::SendWait("^x")
        [System.Windows.Forms.SendKeys]::SendWait($data)
        start-sleep -Milliseconds 10
        [System.Windows.Forms.SendKeys]::SendWait("{enter}")
        start-sleep -Milliseconds 100
        [System.Windows.Forms.SendKeys]::SendWait("^r")
        start-sleep -Milliseconds 1000
        $com.WriteLine("run")   # 送信
    }elseif ( $data.IndexOf('.txt') -ne -1){                                    #".txt"で終わる文字列を受信した場合そのファイル名で波形を保存
        start-sleep -Milliseconds 3000
        [System.Windows.Forms.SendKeys]::SendWait("%f")
        start-sleep -Milliseconds 10
        [System.Windows.Forms.SendKeys]::SendWait("{down 4}")
        start-sleep -Milliseconds 10
        [System.Windows.Forms.SendKeys]::SendWait("{enter}")
        start-sleep -Milliseconds 10
        
        [System.Windows.Forms.SendKeys]::SendWait("{up}")
        [System.Windows.Forms.SendKeys]::SendWait("{right 4}")
        start-sleep -Milliseconds 10
        [System.Windows.Forms.SendKeys]::SendWait("{enter}")
        $retry_cnt = 0
        Set-Clipboard -Value "neko"
        do{
            
            [System.Windows.Forms.SendKeys]::SendWait(".")
            [System.Windows.Forms.SendKeys]::SendWait("^a")
            [System.Windows.Forms.SendKeys]::SendWait("^c")
            start-sleep -Milliseconds 100
            $clip_board = Get-Clipboard -Format Text
            $retry_cnt = $retry_cnt + 1
            if( $retry_cnt -gt 10 ){
                break
            }
        }while( $clip_board -ne "." )
        start-sleep -Milliseconds 10
        [System.Windows.Forms.SendKeys]::SendWait("^a")
        [System.Windows.Forms.SendKeys]::SendWait("^x")
        [System.Windows.Forms.SendKeys]::SendWait($data)
        start-sleep -Milliseconds 10
        [System.Windows.Forms.SendKeys]::SendWait("{enter}")

    } 
}
$com.Close()
$com.Dispose()
